## mingw-w64-seacas-2025.02.27-1.src.tar.zst

=== cmake-use-example/exodus/CMakeLists.txt ===
# Almost all CMake files should start with this
# You should always specify a range with the newest
# and oldest tested versions of CMake. This will ensure
# you pick up the best policies.
cmake_minimum_required(VERSION 3.1...3.26)
project(ExodusCMakeExample VERSION 1.0 LANGUAGES C Fortran)

###
### Generate Makefile with:   
#  * mkdir build; cd build
#  * CMAKE_PREFIX_PATH={path_to_root_of_seacas_install} ccmake ..

#### C ####
find_package(SEACASExodus CONFIG)
add_executable(ExodusWriteC ExodusWrite.c)
target_link_libraries(ExodusWriteC PRIVATE SEACASExodus::all_libs)


#### FORTRAN ##### (Remove all below if only using Exodus C API)
IF ("${CMAKE_Fortran_COMPILER_ID}" MATCHES "GNU")
  SET(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -fcray-pointer -fdefault-real-8 -fdefault-integer-8 -fno-range-check")
ELSEIF ("${CMAKE_Fortran_COMPILER_ID}" MATCHES "XL")
  SET(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -qintsize=8 -qrealsize=8")
ELSEIF ("${CMAKE_Fortran_COMPILER_ID}" MATCHES "Cray")
  SET(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -sdefault64")
ELSE()
  SET(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -r8 -i8")
ENDIF()

find_package(SEACASExodus_for CONFIG)
add_executable(ExodusReadFor ExodusRead.f)
target_link_libraries(ExodusReadFor PRIVATE SEACASExodus_for::all_libs)

=== cmake-use-example/ioss/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1...3.26)
project(IossCMakeExample VERSION 1.0 LANGUAGES CXX)

#### C++ IOSS ####
find_package(SEACASIoss CONFIG)
add_executable(IossExample IossExample.C)
target_link_libraries(IossExample PRIVATE SEACASIoss::all_libs)

=== packages/zoltan/CMakeLists.txt ===


#
# A) Define the package
#

TRIBITS_PACKAGE(Zoltan)

#
# B) Set up package-specific options
#

TRIBITS_ADD_OPTION_AND_DEFINE( ${PACKAGE_NAME}_ENABLE_UINT_IDS
  UNSIGNED_INT_GLOBAL_IDS
  "typedef unsigned int ZOLTAN_ID_TYPE"
  OFF )

TRIBITS_ADD_OPTION_AND_DEFINE( ${PACKAGE_NAME}_ENABLE_ULONG_IDS
  UNSIGNED_LONG_GLOBAL_IDS
  "typedef unsigned long ZOLTAN_ID_TYPE"
  OFF )

TRIBITS_ADD_OPTION_AND_DEFINE( ${PACKAGE_NAME}_ENABLE_ULLONG_IDS
  UNSIGNED_LONG_LONG_GLOBAL_IDS
  "typedef unsigned long long ZOLTAN_ID_TYPE"
  OFF )

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_HUND
  HAVE_ZOLTAN_HUND
  "Enable support for HUND in ${PACKAGE_NAME}."
  OFF )

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_KNUTH_HASH
  HAVE_ZOLTAN_KNUTH_HASH
  "Enable support for Knuth's hash function in ${PACKAGE_NAME}."
  OFF )

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_F90INTERFACE
  BUILD_ZOLTAN_F90_INTERFACE
  "Enable build of F90 interface to ${PACKAGE_NAME}."
  OFF )

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_PURIFY
  HAVE_PURIFY
  "Enable work-arounds to purify bugs."
  OFF )

OPTION(${PACKAGE_NAME}_ENABLE_CPPDRIVER
  "Enable C++ driver for ${PACKAGE_NAME}."
  ${${PROJECT_NAME}_ENABLE_CXX} )

IF (${PROJECT_NAME}_ENABLE_CXX)
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DMPICH_IGNORE_CXX_SEEK")
ENDIF()

IF(${PROJECT_NAME}_ENABLE_Fortran AND BUILD_ZOLTAN_F90_INTERFACE)

  # Special Fortran compiler-specific flags
  IF (${CMAKE_Fortran_COMPILER_ID} MATCHES "PGI")
    SET(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -DPGI")
    SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DPGI")
  ENDIF()

  IF (${CMAKE_Fortran_COMPILER_ID} MATCHES "LAHEY")
    SET(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -DFUJITSU")
    SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DFUJITSU")
  ENDIF()

  SET(ZOLTAN_BUILD_ZFDRIVE YES)
ENDIF()

#
# C) Add the libraries, tests, and examples
#

IF (NOT TPL_ENABLE_MPI)
  ADD_SUBDIRECTORY(siMPI)
  SET(ZOLTAN_BUILD_ZFDRIVE NO)
ENDIF()

ADD_SUBDIRECTORY(src)

#TRIBITS_ADD_TEST_DIRECTORIES(src/driver)

IF(ZOLTAN_BUILD_ZFDRIVE)
  # CMAKE version > 2.6.4 is needed; earlier versions use C++ compiler to link
  # fdriver, while fdriver needs F90.
  TRIBITS_ADD_TEST_DIRECTORIES(src/fdriver)
ENDIF()

#TRIBITS_ADD_TEST_DIRECTORIES(test)

#TRIBITS_ADD_EXAMPLE_DIRECTORIES(example)

TRIBITS_EXCLUDE_FILES(
  test/ch_brack2_3
  test/ch_bug
  test/ch_degenerate
  test/ch_degenerateAA
  test/ch_drake
  test/ch_grid20x19
  test/ch_hammond
  test/ch_hammond2
  test/ch_hughes
  test/ch_nograph
  test/ch_onedbug
  test/ch_random
  test/ch_serial
  test/ch_slac
  test/hg_cage10
  test/hg_diag500_4
  test/hg_ewgt
  test/hg_felix
  test/hg_ibm03
  test/hg_ml27
  test/hg_nograph
  test/hg_vwgt
  test/nem_ti_20k
  test/nem_ti_4k
  test/misc_siefert
  test/th
  test/bin
  doc/Zoltan_html/tu_html
  src/ZoltanComponent
  src/driver_old
  src/fdriver_old
  )

#
# D) Do standard postprocessing
#

TRIBITS_PACKAGE_POSTPROCESS()

=== packages/seacas/scripts/CMakeLists.txt ===
if (${CMAKE_PROJECT_NAME} STREQUAL "Seacas")
  INCLUDE(InstallSymLink)
endif()

SET( ACCESSDIR ${CMAKE_INSTALL_PREFIX} )
SET( SEPARATOR "_")

ASSERT_DEFINED(${PROJECT_NAME}_ENABLE_SEACASNemspread)
ASSERT_DEFINED(${PROJECT_NAME}_ENABLE_SEACASNemslice)
IF (${PROJECT_NAME}_ENABLE_SEACASNemspread AND ${PROJECT_NAME}_ENABLE_SEACASNemslice)
  IF (${PROJECT_NAME}_ENABLE_Zoltan)
     SET( DECOMP_DEFAULT rib )
  ELSE()
     SET( DECOMP_DEFAULT inertial )
  ENDIF()

  CONFIGURE_FILE(
	${CMAKE_CURRENT_SOURCE_DIR}/decomp.in
	${CMAKE_CURRENT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/decomp
	@ONLY
	)
  FILE(COPY ${CMAKE_CURRENT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/decomp
       DESTINATION ${CMAKE_CURRENT_BINARY_DIR}
       FILE_PERMISSIONS OWNER_READ OWNER_WRITE
         OWNER_EXECUTE GROUP_READ GROUP_EXECUTE)
  INSTALL(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/decomp DESTINATION ${CMAKE_INSTALL_BINDIR})
ENDIF()

ASSERT_DEFINED(${PROJECT_NAME}_ENABLE_SEACASBlot)
IF (${PROJECT_NAME}_ENABLE_SEACASBlot)
  CONFIGURE_FILE(
	${CMAKE_CURRENT_SOURCE_DIR}/blot.in
	${CMAKE_CURRENT_BINARY_DIR}/blot
	@ONLY
	)
  INSTALL(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/blot DESTINATION ${CMAKE_INSTALL_BINDIR})
ENDIF()

ASSERT_DEFINED(${PROJECT_NAME}_ENABLE_SEACASFastq)
IF (${PROJECT_NAME}_ENABLE_SEACASFastq)
  CONFIGURE_FILE(
	${CMAKE_CURRENT_SOURCE_DIR}/fastq.in
	${CMAKE_CURRENT_BINARY_DIR}/fastq
	@ONLY
	)
  INSTALL(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/fastq DESTINATION ${CMAKE_INSTALL_BINDIR})
ENDIF()

ASSERT_DEFINED(${PROJECT_NAME}_ENABLE_SEACASEpu)
IF (${PROJECT_NAME}_ENABLE_SEACASEpu)
  CONFIGURE_FILE(
	${CMAKE_CURRENT_SOURCE_DIR}/epup.in
	${CMAKE_CURRENT_BINARY_DIR}/epup
	@ONLY
	)
  INSTALL(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/epup DESTINATION ${CMAKE_INSTALL_BINDIR})
ENDIF()

ASSERT_DEFINED(${PROJECT_NAME}_ENABLE_SEACASConjoin)
IF (${PROJECT_NAME}_ENABLE_SEACASConjoin)
  CONFIGURE_FILE(
	${CMAKE_CURRENT_SOURCE_DIR}/pconjoin.in
	${CMAKE_CURRENT_BINARY_DIR}/pconjoin
	@ONLY
	)
  INSTALL(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/pconjoin DESTINATION ${CMAKE_INSTALL_BINDIR})
ENDIF()

TRIBITS_INCLUDE_DIRECTORIES(
  "${CMAKE_CURRENT_SOURCE_DIR}"
)

SET(HEADERS "")

IF (NOT CMAKE_HOST_SYSTEM_NAME STREQUAL "Windows")
   APPEND_GLOB(SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/getopt.seacas.c)
   ASSERT_DEFINED(${PROJECT_NAME}_ENABLE_SEACASBlot)
   ASSERT_DEFINED(${PROJECT_NAME}_ENABLE_SEACASFastq)
   ASSERT_DEFINED(${PROJECT_NAME}_ENABLE_SEACASEpu)
   IF (${PROJECT_NAME}_ENABLE_SEACASBlot OR
       ${PROJECT_NAME}_ENABLE_SEACASFastq OR
       ${PROJECT_NAME}_ENABLE_SEACASEpu)
      ADD_EXECUTABLE(getopt.seacas ${SOURCES} )
      install_executable(getopt.seacas)
   endif()
ENDIF()

ASSERT_DEFINED(${PROJECT_NAME}_ENABLE_SEACASExodus)
ASSERT_DEFINED(BUILD_SHARED_LIBS)
IF (${PROJECT_NAME}_ENABLE_SEACASExodus)
   find_package(Python COMPONENTS Interpreter Development)
   IF (${Python_FOUND})
      message(STATUS "Found python version ${Python_VERSION}")
      IF (${Python_VERSION} VERSION_LESS "3.0")
	 SET( EXODUSPY "exodus2.py" )
	 SET( EXOMERGE "exomerge2.py")
	 MESSAGE(STATUS "A Python-2 version of exodus.py and exomerge.py will be installed.")
      ELSE()
	 SET( EXODUSPY "exodus3.py" )
	 SET( EXOMERGE "exomerge3.py")
	 IF (NOT ${PROJECT_NAME}_HOSTNAME STREQUAL "APPVEYOR-VM")
            ADD_TEST(NAME test_exodus3.py COMMAND ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/tests/test_exodus3.py)
            ADD_TEST(NAME test_exomerge3.py COMMAND ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/tests/exomerge_unit_test.py)
	 ENDIF()
	 MESSAGE(STATUS "A Python-3 version of exodus.py and exomerge.py will be installed.")
      ENDIF()

      IF (BUILD_SHARED_LIBS OR SEACASExodus_ENABLE_SHARED)
         FILE(GLOB_RECURSE EXODUSIIH "${CMAKE_SOURCE_DIR}/packages/seacas/*exodusII.h")
         FILE(STRINGS "${EXODUSIIH}" EXODUS_VERSION REGEX "#define EXODUS_VERSION .*")
         CONFIGURE_FILE(
             ${CMAKE_CURRENT_SOURCE_DIR}/exodus2.in.py
             ${CMAKE_CURRENT_BINARY_DIR}/exodus2.py
             @ONLY
             )
         CONFIGURE_FILE(
             ${CMAKE_CURRENT_SOURCE_DIR}/exodus3.in.py
             ${CMAKE_CURRENT_BINARY_DIR}/exodus3.py
             @ONLY
             )
         CONFIGURE_FILE(
             ${CMAKE_CURRENT_SOURCE_DIR}/tests/exomerge_unit_test.py
             ${CMAKE_CURRENT_BINARY_DIR}/tests/exomerge_unit_test.py
             @ONLY
             )
         CONFIGURE_FILE(
             ${CMAKE_CURRENT_SOURCE_DIR}/exomerge3.py
             ${CMAKE_CURRENT_BINARY_DIR}/exomerge3.py
             @ONLY
             )
         CONFIGURE_FILE(
             ${CMAKE_CURRENT_SOURCE_DIR}/exomerge2.py
             ${CMAKE_CURRENT_BINARY_DIR}/exomerge2.py
             @ONLY
             )
         CONFIGURE_FILE(
             ${CMAKE_CURRENT_SOURCE_DIR}/tests/test_exodus3.py
             ${CMAKE_CURRENT_BINARY_DIR}/tests/test_exodus3.py
             @ONLY
             )
         CONFIGURE_FILE(
             ${CMAKE_CURRENT_SOURCE_DIR}/tests/test-assembly.exo
             ${CMAKE_CURRENT_BINARY_DIR}/tests/test-assembly.exo
             COPYONLY
             )

         INSTALL(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/exodus2.py DESTINATION ${CMAKE_INSTALL_LIBDIR})
         INSTALL(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/exodus3.py DESTINATION ${CMAKE_INSTALL_LIBDIR})
         INSTALL(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/tests/test_exodus3.py DESTINATION ${CMAKE_INSTALL_LIBDIR}/tests/)
         INSTALL(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/tests/exomerge_unit_test.py DESTINATION ${CMAKE_INSTALL_LIBDIR}/tests/)
         INSTALL(PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/tests/test-assembly.exo DESTINATION ${CMAKE_INSTALL_LIBDIR}/tests/)
         INSTALL(PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/tests/exomerge_unit_test.e DESTINATION ${CMAKE_INSTALL_LIBDIR}/tests/)
         INSTALL(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/exomerge2.py DESTINATION ${CMAKE_INSTALL_LIBDIR})
         INSTALL(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/exomerge3.py DESTINATION ${CMAKE_INSTALL_LIBDIR})

         if (${CMAKE_PROJECT_NAME} STREQUAL "Seacas" AND NOT WIN32)
            InstallSymLink(${EXODUSPY} ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/exodus.py)
            InstallSymLink(${EXOMERGE} ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/exomerge.py)
         endif()
      ELSE()
         MESSAGE(STATUS "Exodus.py and exomerge.py NOT installed since shared exodus library is not available.")
      ENDIF()
   else()
      MESSAGE(STATUS "Exodus.py and exomerge.py NOT installed since Python could not be found.")
   endif()
ELSE()
   MESSAGE(STATUS "Exodus.py and exomerge.py NOT installed since Exodus is not enabled.")
endif()

=== packages/zoltan/src/CMakeLists.txt ===


#
# A) Package-specific configuration options
#

ASSERT_DEFINED(${PACKAGE_NAME}_ENABLE_METIS)
SET(HAVE_METIS ${${PACKAGE_NAME}_ENABLE_METIS})

ASSERT_DEFINED(${PACKAGE_NAME}_ENABLE_ParMETIS)
SET(HAVE_PARMETIS ${${PACKAGE_NAME}_ENABLE_ParMETIS})

ASSERT_DEFINED(${PACKAGE_NAME}_ENABLE_PaToH)
SET(HAVE_PATOH ${${PACKAGE_NAME}_ENABLE_PaToH})

ASSERT_DEFINED(${PACKAGE_NAME}_ENABLE_Scotch)
SET(HAVE_SCOTCH ${${PACKAGE_NAME}_ENABLE_Scotch})

ASSERT_DEFINED(${PACKAGE_NAME}_ENABLE_OVIS)
SET(HAVE_OVIS ${${PACKAGE_NAME}_ENABLE_OVIS})

ASSERT_DEFINED(${PACKAGE_NAME}_ENABLE_Zlib)
SET(ZHAVE_GZIP ${${PACKAGE_NAME}_ENABLE_Zlib})

ASSERT_DEFINED(${PACKAGE_NAME}_ENABLE_PURIFY)
SET(HAVE_PURIFY ${${PACKAGE_NAME}_ENABLE_PURIFY})

TRIBITS_CONFIGURE_FILE(${PACKAGE_NAME}_config.h)

#
# B) Define the header and source files (and directories)
#

#
# src
#

SET(HEADERS "")
SET(NOINSTALLHEADERS "")
SET(SOURCES "")
SET(MODULES "")

TRIBITS_INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})

SET(HEADERS ${HEADERS}
  ${CMAKE_CURRENT_BINARY_DIR}/${PACKAGE_NAME}_config.h
  )

#
# src/include
#

TRIBITS_INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/include)

APPEND_SET(HEADERS
  include/lbi_const.h
  include/zoltan_align.h
  include/zoltan_cpp.h
  include/zoltan.h
  include/zoltan_types.h
  include/zoltan_comm.h
  include/zoltan_comm_cpp.h
  include/zoltan_timer_cpp.h
  include/zoltan_timer.h
  include/zoltan_dd.h
  Utilities/DDirectory/zoltan_dd_const.h
  include/zoltan_dd_cpp.h
  include/zoltan_partition_tree.h
  include/zoltan_mem.h
  include/zoltan_eval.h
  )

#
# src/all
#

TRIBITS_INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/all)

APPEND_SET(NOINSTALLHEADERS
  all/all_allo_const.h
  )

APPEND_SET(SOURCES
  all/all_allo.c
  )

#
# src/coloring
#

TRIBITS_INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/coloring)

APPEND_SET(NOINSTALLHEADERS
  coloring/coloring_const.h
  coloring/coloring.h
  coloring/g2l_hash.h
  coloring/bucket.h
  )

APPEND_SET(SOURCES
  coloring/coloring.c
  coloring/color_test.c
  coloring/g2l_hash.c
  coloring/bucket.c
  )

#
# src/graph
#

TRIBITS_INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/graph)

APPEND_SET(NOINSTALLHEADERS
  graph/graph.h
  graph/graph_const.h
  )

APPEND_SET(SOURCES
  graph/graph.c
  )


#
# src/ha
#

TRIBITS_INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/ha)

APPEND_SET(NOINSTALLHEADERS
  ha/ha_const.h
  ha/ha_ovis.h
  )

APPEND_SET(SOURCES
  ha/divide_machine.c
  ha/get_processor_name.c
  ha/ha_ovis.c
  )

#
# src/hier
#

TRIBITS_INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/hier)

APPEND_SET(NOINSTALLHEADERS
  hier/hier.h
  )

APPEND_SET(SOURCES
  hier/hier.c
  hier/hier_free_struct.c
  )

#
# src/hsfc
#

TRIBITS_INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/hsfc)

APPEND_SET(NOINSTALLHEADERS
  hsfc/hsfc.h
  hsfc/hsfc_const.h
  hsfc/hsfc_hilbert_const.h
  )

APPEND_SET(SOURCES
  hsfc/hsfc_box_assign.c
  hsfc/hsfc.c
  hsfc/hsfc_hilbert.c
  hsfc/hsfc_point_assign.c
  )

#
# src/lb
#

TRIBITS_INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/lb)

APPEND_SET(NOINSTALLHEADERS
  lb/lb_const.h
  lb/lb_init_const.h
  )

APPEND_SET(SOURCES
  lb/lb_balance.c
  lb/lb_box_assign.c
  lb/lb_copy.c
  lb/lb_eval.c
  lb/lb_free.c
  lb/lb_init.c
  lb/lb_invert.c
  lb/lb_migrate.c
  lb/lb_part2proc.c
  lb/lb_point_assign.c
  lb/lb_remap.c
  lb/lb_set_fn.c
  lb/lb_set_method.c
  lb/lb_set_part_sizes.c
  )

#
# src/matrix
#

TRIBITS_INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/matrix)

APPEND_SET(NOINSTALLHEADERS
  matrix/zoltan_matrix.h
  )

APPEND_SET(SOURCES
  matrix/matrix_build.c
  matrix/matrix_distribute.c
  matrix/matrix_operations.c
  matrix/matrix_sym.c
  matrix/matrix_utils.c
  )

#
# src/order
#

TRIBITS_INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/order)

APPEND_SET(NOINSTALLHEADERS
  order/order_const.h
  )

APPEND_SET(SOURCES
  order/hsfcOrder.c
  order/order.c
  order/order_struct.c
  order/order_tools.c
  order/perm.c
  )

IF (${PACKAGE_NAME}_ENABLE_HUND)
  APPEND_SET(SOURCES
    order/hund.c
    )
ENDIF()
#
# src/par
#

TRIBITS_INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/par)

APPEND_SET(NOINSTALLHEADERS
  par/par_average_const.h
  par/par_bisect_const.h
  par/par_const.h
  par/par_median_const.h
  par/par_tflops_special_const.h
  )

APPEND_SET(SOURCES
  par/par_average.c
  par/par_bisect.c
  par/par_median.c
  par/par_median_randomized.c
  par/par_stats.c
  par/par_sync.c
  par/par_tflops_special.c
  )

#
# src/params
#

TRIBITS_INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/params)

APPEND_SET(NOINSTALLHEADERS
  params/key_params.h
  params/params_const.h
  )

APPEND_SET(SOURCES
  params/assign_param_vals.c
  params/bind_param.c
  params/check_param.c
  params/free_params.c
  params/key_params.c
  params/print_params.c
  params/set_param.c
  )



#
# src/tpls
#

TRIBITS_INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/tpls)

APPEND_SET(NOINSTALLHEADERS
  tpls/third_library_const.h
  tpls/third_library.h
  tpls/third_library_tools.h
  tpls/graph_util.h
  )

APPEND_SET(SOURCES
  tpls/build_graph.c
  tpls/postprocessing.c
  tpls/preprocessing.c
  tpls/scatter_graph.c
  tpls/third_library.c
  tpls/verify_graph.c
  )

IF (${PACKAGE_NAME}_ENABLE_ParMETIS OR ${PACKAGE_NAME}_ENABLE_METIS)

  APPEND_SET(NOINSTALLHEADERS
    tpls/parmetis_interface.h
    )

  APPEND_SET(SOURCES
    tpls/parmetis_interface.c
    )

ENDIF()

IF (${PACKAGE_NAME}_ENABLE_Scotch)

  APPEND_SET(NOINSTALLHEADERS
  tpls/scotch_interface.h
    )

  APPEND_SET(SOURCES
  tpls/scotch_interface.c
    )

ENDIF()


#
# src/phg
#

TRIBITS_INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/phg)

APPEND_SET(NOINSTALLHEADERS
  phg/phg_comm.h
  phg/phg_const.h
  phg/phg_distrib.h
  phg/phg.h
  phg/phg_lookup.h
  phg/phg_verbose.h
  phg/phg_hypergraph.h
  phg/phg_tree.h
  phg/phg_util.h
  )

APPEND_SET(SOURCES
  phg/phg_build.c
  phg/phg_build_calls.c
  phg/phg.c
  phg/phg_lookup.c
  phg/phg_verbose.c
  phg/phg_coarse.c
  phg/phg_comm.c
  phg/phg_distrib.c
  phg/phg_gather.c
  phg/phg_hypergraph.c
  phg/phg_match.c
  phg/phg_order.c
  phg/phg_parkway.c
  phg/phg_patoh.c
  phg/phg_plot.c
  phg/phg_rdivide.c
  phg/phg_refinement.c
  phg/phg_scale.c
  phg/phg_serialpartition.c
  phg/phg_tree.c
  phg/phg_partition_tree.c
  phg/phg_two_ways.c
  phg/phg_util.c
  phg/phg_Vcycle.c
  )

#
# src/rcb
#

TRIBITS_INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/rcb)

APPEND_SET(NOINSTALLHEADERS
  rcb/create_proc_list_const.h
  rcb/rcb_const.h
  rcb/rcb.h
  rcb/rib_const.h
  rcb/rib.h
  rcb/shared.h
  )

APPEND_SET(SOURCES
  rcb/box_assign.c
  rcb/create_proc_list.c
  rcb/inertial1d.c
  rcb/inertial2d.c
  rcb/inertial3d.c
  rcb/point_assign.c
  rcb/rcb_box.c
  rcb/rcb_partition_tree.c
  rcb/rcb.c
  rcb/rcb_util.c
  rcb/rib.c
  rcb/rib_util.c
  rcb/shared.c
  )

#
# src/reftree
#

TRIBITS_INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/reftree)

APPEND_SET(NOINSTALLHEADERS
  reftree/reftree_const.h
  reftree/reftree.h
  )

APPEND_SET(SOURCES
  reftree/reftree_build.c
  reftree/reftree_coarse_path.c
  reftree/reftree_hash.c
  reftree/reftree_part.c
  )

#
# src/simple
#

TRIBITS_INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/simple)

APPEND_SET(SOURCES
  simple/block.c
  simple/cyclic.c
  simple/random.c
  )

APPEND_SET(NOINSTALLHEADERS
  simple/simple_const.h
  )

#
# src/timer
#

TRIBITS_INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/timer)

APPEND_SET(NOINSTALLHEADERS
  timer/timer_const.h
  )

APPEND_SET(SOURCES
  timer/timer_params.c
  )

#
# src/Utilities
#

TRIBITS_INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/Utilities/Communication)
TRIBITS_INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/Utilities/DDirectory)
TRIBITS_INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/Utilities/Timer)
TRIBITS_INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/Utilities/shared)

APPEND_SET(NOINSTALLHEADERS
  Utilities/Communication/comm.h
  Utilities/DDirectory/DD_Memory.h
  Utilities/Timer/timer.h
  Utilities/shared/zoltan_util.h
  Utilities/shared/zoltan_id.h
  )

APPEND_SET(SOURCES
  Utilities/Communication/comm_exchange_sizes.c
  Utilities/Communication/comm_invert_map.c
  Utilities/Communication/comm_do.c
  Utilities/Communication/comm_do_reverse.c
  Utilities/Communication/comm_info.c
  Utilities/Communication/comm_create.c
  Utilities/Communication/comm_resize.c
  Utilities/Communication/comm_sort_ints.c
  Utilities/Communication/comm_destroy.c
  Utilities/Communication/comm_invert_plan.c
  Utilities/Timer/zoltan_timer.c
  Utilities/Timer/timer.c
  Utilities/DDirectory/DD_Find.c
  Utilities/DDirectory/DD_Destroy.c
  Utilities/DDirectory/DD_Set_Neighbor_Hash_Fn3.c
  Utilities/DDirectory/DD_Remove.c
  Utilities/DDirectory/DD_Create.c
  Utilities/DDirectory/DD_Update.c
  Utilities/DDirectory/DD_Stats.c
  Utilities/DDirectory/DD_Hash2.c
  Utilities/DDirectory/DD_Memory.c
  Utilities/DDirectory/DD_Print.c
  Utilities/DDirectory/DD_Set_Neighbor_Hash_Fn2.c
  Utilities/DDirectory/DD_Set_Hash_Fn.c
  Utilities/DDirectory/DD_Set_Neighbor_Hash_Fn1.c
  Utilities/Memory/mem.c
  Utilities/shared/zoltan_align.c
  Utilities/shared/zoltan_id.c
  )

#
# src/zz
#

TRIBITS_INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/zz)

APPEND_SET(NOINSTALLHEADERS
  zz/zz_const.h
  zz/zz_hash.h
  zz/zz_heap.h
  zz/zz_id_const.h
  zz/zz_rand.h
  zz/zz_sort.h
  zz/zz_util_const.h
  )

APPEND_SET(SOURCES
  zz/zz_coord.c
  zz/zz_gen_files.c
  zz/zz_hash.c
  zz/zz_map.c
  zz/zz_heap.c
  zz/zz_init.c
  zz/zz_obj_list.c
  zz/zz_rand.c
  zz/zz_set_fn.c
  zz/zz_sort.c
  zz/zz_struct.c
  zz/zz_back_trace.c
  zz/zz_util.c
  )


#
# src/fort
#

IF(${PROJECT_NAME}_ENABLE_Fortran AND BUILD_ZOLTAN_F90_INTERFACE)
  TRIBITS_INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/fort)

  APPEND_SET(NOINSTALLHEADERS
    fort/cwrap_fmangle.h
    fort/set_borderobjlist.fn
    fort/set_borderobjlist.if
    fort/set_childlist.fn
    fort/set_childlist.if
    fort/set_childweight.fn
    fort/set_childweight.if
    fort/set_coarseobjlist.fn
    fort/set_coarseobjlist.if
    fort/set_edgelist.fn
    fort/set_edgelist.if
    fort/set_edgelistmulti.fn
    fort/set_edgelistmulti.if
    fort/set_firstborderobj.fn
    fort/set_firstborderobj.if
    fort/set_firstcoarseobj.fn
    fort/set_firstcoarseobj.if
    fort/set_firstobj.fn
    fort/set_firstobj.if
    fort/set_fixedobjlist.fn
    fort/set_fixedobjlist.if
    fort/set_geom.fn
    fort/set_geom.if
    fort/set_geommulti.fn
    fort/set_geommulti.if
    fort/set_hgcs.fn
    fort/set_hgcs.if
    fort/set_hgedgeweights.fn
    fort/set_hgedgeweights.if
    fort/set_hgsizecs.fn
    fort/set_hgsizecs.if
    fort/set_hgsizeedgeweights.fn
    fort/set_hgsizeedgeweights.if
    fort/set_hiermethod.fn
    fort/set_hiermethod.if
    fort/set_hiernumlevels.fn
    fort/set_hiernumlevels.if
    fort/set_hierpartition.fn
    fort/set_hierpartition.if
    fort/set_midmigrate.fn
    fort/set_midmigrate.if
    fort/set_midmigratepp.fn
    fort/set_midmigratepp.if
    fort/set_nextborderobj.fn
    fort/set_nextborderobj.if
    fort/set_nextcoarseobj.fn
    fort/set_nextcoarseobj.if
    fort/set_nextobj.fn
    fort/set_nextobj.if
    fort/set_numborderobj.fn
    fort/set_numborderobj.if
    fort/set_numchild.fn
    fort/set_numchild.if
    fort/set_numcoarseobj.fn
    fort/set_numcoarseobj.if
    fort/set_numedges.fn
    fort/set_numedges.if
    fort/set_numedgesmulti.fn
    fort/set_numedgesmulti.if
    fort/set_numfixedobj.fn
    fort/set_numfixedobj.if
    fort/set_numgeom.fn
    fort/set_numgeom.if
    fort/set_numobj.fn
    fort/set_numobj.if
    fort/set_objlist.fn
    fort/set_objlist.if
    fort/set_objsize.fn
    fort/set_objsize.if
    fort/set_objsizemulti.fn
    fort/set_objsizemulti.if
    fort/set_packobj.fn
    fort/set_packobj.if
    fort/set_packobjmulti.fn
    fort/set_packobjmulti.if
    fort/set_partition.fn
    fort/set_partition.if
    fort/set_partitionmulti.fn
    fort/set_partitionmulti.if
    fort/set_postmigrate.fn
    fort/set_postmigrate.if
    fort/set_postmigratepp.fn
    fort/set_postmigratepp.if

=== cmake/tribits/doc/build_ref/Makefile ===
##---------------------------------------------------------------------------##
## MAKEFILE
##---------------------------------------------------------------------------##

EXTRA_ARGS=

.PHONY: clean realclean all

BASE_NAME = TribitsBuildReference
EXTRA_FILES = \
  Makefile \
  TribitsBuildReferenceBody.rst \
  TribitsBuildReferenceTemplate.rst

# NOTE: We *don't* want to rebuild the file if only the version has changed we
# don't add a dependency on TribitsGitVersion.txt!

CREATE_PROJECT_BUILD_REF_CMND = \
	./create-project-build-ref.py \
	--project-name="<Project>" \
	--project-template-file=TribitsBuildReferenceTemplate.rst \
	--file-base=TribitsBuildReference

all: $(EXTRA_FILES)
	$(CREATE_PROJECT_BUILD_REF_CMND) \
	$(EXTRA_ARGS)

$(BASE_NAME).rst: $(EXTRA_FILES)
	$(CREATE_PROJECT_BUILD_REF_CMND) \
	--generate-html= --generate-latex= --generate-pdf= \
	$(EXTRA_ARGS)

clean:
	-rm -f $(BASE_NAME).rst
	-rm -f $(BASE_NAME).html
	-rm -f $(BASE_NAME).pdf

##---------------------------------------------------------------------------##
## end of Makefile
##---------------------------------------------------------------------------##

=== cmake/tribits/doc/sphinx/requirements.txt ===
Sphinx==8.2.1
sphinx-rtd-theme==3.0.2

=== packages/seacas/applications/exo2mat/CMakeLists.txt ===

IF (TPL_ENABLE_Matio)
TRIBITS_SUBPACKAGE(Exo2mat)

LINK_DIRECTORIES(${Matio_LIBRARY_DIRS})
TRIBITS_INCLUDE_DIRECTORIES(
  "${Matio_INCLUDE_DIRS}"
  "${CMAKE_CURRENT_SOURCE_DIR}"
)

SET(CODE exo2mat)
SET(HEADERS "")

TRIBITS_ADD_EXECUTABLE(
  ${CODE}
  NOEXEPREFIX
  NOEXESUFFIX
  SOURCES exo2mat.C
  COMM serial mpi
  INSTALLABLE
  )

TRIBITS_SUBPACKAGE_POSTPROCESS()
ENDIF()

=== packages/seacas/applications/mapvar-kd/CMakeLists.txt ===
INCLUDE(FortranSettings)

TRIBITS_SUBPACKAGE(Mapvar-kd)

TRIBITS_INCLUDE_DIRECTORIES(
  "${CMAKE_CURRENT_SOURCE_DIR}"
)

SET(HEADERS "")
APPEND_GLOB(SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/*.f)
APPEND_GLOB(SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/*.c)

TRIBITS_ADD_EXECUTABLE(
  mapvar-kd
  NOEXEPREFIX
  NOEXESUFFIX
  LINKER_LANGUAGE Fortran
  SOURCES ${SOURCES}
  COMM serial mpi
  INSTALLABLE
  )

SET_PROPERTY(TARGET mapvar-kd  PROPERTY POSITION_INDEPENDENT_CODE TRUE)
TRIBITS_SUBPACKAGE_POSTPROCESS()

=== packages/zoltan/src/driver/CMakeLists.txt ===

SET(COMMON_DRIVER_SRC
  dr_err.c
  dr_input.c
  dr_par_util.c
  dr_util.c
  dr_elem.c
  dr_setfixed.c
  dr_output.c
  dr_chaco_io.c
  dr_random_io.c
  dr_elem_util.c
  dr_eval.c
  dr_gnuplot.c
  dr_hg_io.c
  dr_hg_readfile.c
  dr_mm_readfile.c
  dr_mmio.c
  ${PACKAGE_SOURCE_DIR}/src/ch/ch_dist_graph.c
  ${PACKAGE_SOURCE_DIR}/src/ch/ch_input_assign.c
  ${PACKAGE_SOURCE_DIR}/src/ch/ch_input_graph.c
  ${PACKAGE_SOURCE_DIR}/src/ch/ch_init_dist.c
  ${PACKAGE_SOURCE_DIR}/src/ch/ch_input_geom.c
  ${PACKAGE_SOURCE_DIR}/src/ch/ch_input_read.c
  )

IF (${PACKAGE_NAME}_ENABLE_Zlib)

  APPEND_SET(COMMON_DRIVER_SRC
  dr_compress.c
    )

ENDIF()


SET(COMMON_DRIVER_HDRS
  dr_compress_const.h
  dr_hg_readfile.h
  dr_const.h
  dr_externs.h
  dr_input_const.h
  dr_util_const.h
  dr_err_const.h
  dr_par_util_const.h
  dr_elem_const.h
  dr_elem_util_const.h
  dr_maps_const.h
  dr_eval_const.h
  dr_loadbal_const.h
  dr_mmio.h
  dr_output_const.h
  dr_param_file.h
  dr_dd.h
  ${PACKAGE_SOURCE_DIR}/src/ch/ch_input_const.h
  ${PACKAGE_SOURCE_DIR}/src/ch/ch_init_dist_const.h
  )

SET(ZDRIVE_SOURCES
  ${COMMON_DRIVER_SRC}
  dr_main.c
  dr_exoII_io.c
  dr_loadbal.c
  dr_migrate.c
  dr_maps.c
  dr_dd.c
  dr_param_file.c
  order_test.c
  )

SET(ZCPPDRIVE_SOURCES
  ${COMMON_DRIVER_SRC}
  dr_mainCPP.cpp
  dr_exoII_ioCPP.cpp
  dr_loadbalCPP.cpp
  dr_migrateCPP.cpp
  dr_mapsCPP.cpp
  dr_ddCPP.cpp
  dr_param_fileCPP.cpp
  )


TRIBITS_INCLUDE_DIRECTORIES(REQUIRED_DURING_INSTALLATION_TESTING ${CMAKE_CURRENT_SOURCE_DIR})
TRIBITS_INCLUDE_DIRECTORIES(REQUIRED_DURING_INSTALLATION_TESTING ${PACKAGE_SOURCE_DIR}/src/ch)

TRIBITS_ADD_EXECUTABLE(
  zdrive
  NOEXEPREFIX
  SOURCES ${COMMON_DRIVER_HDRS} ${ZDRIVE_SOURCES}
  COMM serial mpi
  CATEGORIES BASIC PERFORMANCE
  )

IF (${PACKAGE_NAME}_ENABLE_CPPDRIVER)
  TRIBITS_ADD_EXECUTABLE(
    zCPPdrive
    NOEXEPREFIX
    SOURCES ${COMMON_DRIVER_HDRS} ${ZCPPDRIVE_SOURCES}
    COMM serial mpi
    )

ENDIF()

=== packages/seacas/libraries/ioss/src/main/CMakeLists.txt ===
SET(HEADERS "")
SET(SOURCES "")

TRIBITS_SET_AND_INC_DIRS(DIR ${CMAKE_CURRENT_SOURCE_DIR})
APPEND_GLOB(HEADERS ${DIR}/*.h)
APPEND_GLOB(SOURCES ${DIR}/*.C)

TRIBITS_INCLUDE_DIRECTORIES(
  "${CMAKE_CURRENT_SOURCE_DIR}/../"
  "${CMAKE_CURRENT_BINARY_DIR}/../"
)

list(APPEND HEADERS
  "${CMAKE_CURRENT_BINARY_DIR}/io_info_lib_export.h")

TRIBITS_ADD_LIBRARY(
  io_info_lib
  HEADERS io_info.h info_interface.h
  SOURCES io_info.C volume.C info_interface.C
  DEPLIBS Ioss
  )

generate_export_header(io_info_lib)
target_include_directories(io_info_lib
  PUBLIC
    "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>")

ASSERT_DEFINED(TPL_ENABLE_CGNS)
IF (TPL_ENABLE_CGNS)
TRIBITS_ADD_EXECUTABLE(
  struc_to_unstruc
  NOEXEPREFIX
  NOEXESUFFIX
  SOURCES struc_to_unstruc.C
  INSTALLABLE
  )

TRIBITS_ADD_EXECUTABLE(
  cgns_decomp
  NOEXEPREFIX
  NOEXESUFFIX
  SOURCES cgns_decomp.C
  INSTALLABLE
  )
ENDIF()

TRIBITS_ADD_EXECUTABLE(
  cth_pressure_map
  NOEXEPREFIX
  NOEXESUFFIX
  SOURCES cth_pressure_map.C vector3d.C
  INSTALLABLE
  )
TRIBITS_ADD_EXECUTABLE(
  io_shell
  NOEXEPREFIX
  NOEXESUFFIX
  SOURCES io_shell.C shell_interface.C
  INSTALLABLE
  )
TRIBITS_ADD_EXECUTABLE(
  shell_to_hex
  NOEXEPREFIX
  NOEXESUFFIX
  SOURCES shell_to_hex.C vector3d.C
  INSTALLABLE
  )
TRIBITS_ADD_EXECUTABLE(
  io_info
  NOEXEPREFIX
  NOEXESUFFIX
  SOURCES io_info_main.C
  INSTALLABLE
  )

IF (${PACKAGE_NAME}_ENABLE_SEACASExodus)
TRIBITS_ADD_EXECUTABLE(
  io_modify
  NOEXEPREFIX
  NOEXESUFFIX
  SOURCES io_modify.C modify_interface.C
  INSTALLABLE
  )
endif()

TRIBITS_ADD_EXECUTABLE(
  sphgen
  NOEXEPREFIX
  NOEXESUFFIX
  SOURCES sphgen.C
  INSTALLABLE
  )

TRIBITS_ADD_EXECUTABLE(
  skinner
  NOEXEPREFIX
  NOEXESUFFIX
  SOURCES skinner.C skinner_interface.C
  INSTALLABLE
  )

if (TPL_ENABLE_MPI)
  IF (TPL_Netcdf_PARALLEL)
    set(DECOMP_ARG "--rcb")
    set(JOIN_ARG   "--compose=mpiio")
    set(PJOIN_ARG   "--compose=pnetcdf")
    set(NPROCS "4")
    set(NPROCS_BUG "1")
    set(SERIALIZE_ARG "--serialize_io_size=2")
  else()
    set(NPROCS "1")
    set(NPROCS_BUG "1")
  endif()
endif()

if (${CMAKE_PROJECT_NAME}_ENABLE_SEACASExodiff)
TRIBITS_ADD_ADVANCED_TEST(exodus32_to_exodus32
   TEST_0 EXEC io_shell ARGS ${DECOMP_ARG} ${JOIN_ARG} ${CMAKE_CURRENT_SOURCE_DIR}/test/8-block.g 8-block32.g
     NOEXEPREFIX NOEXESUFFIX
     NUM_MPI_PROCS ${NPROCS}
   TEST_1 EXEC exodiff ARGS -pedantic ${CMAKE_CURRENT_SOURCE_DIR}/test/8-block.g 8-block32.g
       DIRECTORY ../../../../applications/exodiff
       NOEXEPREFIX NOEXESUFFIX
       NUM_MPI_PROCS 1
  COMM mpi serial
  XHOSTTYPE Windows
  )

  if (TPL_Netcdf_Enables_Netcdf4)
  SET(IOSHELL_ARG --in_type generated 10x10x10+shell:xXyYzZ+times:4+variables:element,2,nodal,3)
  SET(SPLIT_ARG --split_times 1)
  TRIBITS_ADD_ADVANCED_TEST(
    io_shell_group_ungroup
    TEST_0 NOEXEPREFIX NOEXESUFFIX EXEC io_shell ARGS ${SPLIT_ARG} ${IOSHELL_ARG} splits.g
    TEST_1 NOEXEPREFIX NOEXESUFFIX EXEC io_shell ARGS splits.g_1 splits.g_2 splits.g_3 splits.g_4  grouped.g
    TEST_2 NOEXEPREFIX NOEXESUFFIX EXEC io_shell ARGS --extract_group splits.g_1 grouped.g split-extract.g_1
    TEST_3 NOEXEPREFIX NOEXESUFFIX EXEC io_shell ARGS --extract_group splits.g_2 grouped.g split-extract.g_2
    TEST_4 NOEXEPREFIX NOEXESUFFIX EXEC io_shell ARGS --extract_group splits.g_3 grouped.g split-extract.g_3
    TEST_5 NOEXEPREFIX NOEXESUFFIX EXEC io_shell ARGS --extract_group splits.g_4 grouped.g split-extract.g_4
    TEST_6 EXEC exodiff ARGS -pedantic splits.g_1 split-extract.g_1
       DIRECTORY ../../../../applications/exodiff
       NOEXEPREFIX NOEXESUFFIX
       NUM_MPI_PROCS 1
    TEST_7 EXEC exodiff ARGS -pedantic splits.g_2 split-extract.g_2
       DIRECTORY ../../../../applications/exodiff
       NOEXEPREFIX NOEXESUFFIX
       NUM_MPI_PROCS 1
    TEST_8 EXEC exodiff ARGS -pedantic splits.g_3 split-extract.g_3
       DIRECTORY ../../../../applications/exodiff
       NOEXEPREFIX NOEXESUFFIX
       NUM_MPI_PROCS 1
    TEST_9 EXEC exodiff ARGS -pedantic splits.g_4 split-extract.g_4
       DIRECTORY ../../../../applications/exodiff
       NOEXEPREFIX NOEXESUFFIX
       NUM_MPI_PROCS 1
    COMM serial
    FINAL_PASS_REGULAR_EXPRESSION
  )

  IF (TPL_Netcdf_PARALLEL)
  TRIBITS_ADD_ADVANCED_TEST(
    io_shell_cs_decompose_compose
    TEST_0 NOEXEPREFIX NOEXESUFFIX EXEC io_shell ARGS ${SPLIT_ARG} ${IOSHELL_ARG} splits_cs.g
       NUM_MPI_PROCS 1
    TEST_1 NOEXEPREFIX NOEXESUFFIX EXEC io_shell ARGS splits_cs.g_1 splits_cs.g_2 splits_cs.g_3 splits_cs.g_4  grouped_cs.g
       NUM_MPI_PROCS 1
    TEST_3 EXEC io_shell ARGS ${DECOMP_ARG} ${JOIN_ARG} grouped_cs.g joined_cs.g
     NOEXEPREFIX NOEXESUFFIX
     NUM_MPI_PROCS ${NPROCS}
    TEST_4 EXEC exodiff ARGS -pedantic grouped_cs.g joined_cs.g
       DIRECTORY ../../../../applications/exodiff
       NOEXEPREFIX NOEXESUFFIX
       NUM_MPI_PROCS 1
    COMM mpi serial
    XHOSTTYPE Windows
    FINAL_PASS_REGULAR_EXPRESSION
  )

  TRIBITS_ADD_ADVANCED_TEST(
    io_shell_cs_decompose_epu
    TEST_0 NOEXEPREFIX NOEXESUFFIX EXEC io_shell ARGS ${SPLIT_ARG} ${IOSHELL_ARG} splits_epu.g
       NUM_MPI_PROCS 1
    TEST_1 NOEXEPREFIX NOEXESUFFIX EXEC io_shell ARGS splits_epu.g_1 splits_epu.g_2 splits_epu.g_3 splits_epu.g_4  grouped1_epu.g
       NUM_MPI_PROCS 1
    TEST_3 EXEC io_shell ARGS ${DECOMP_ARG} grouped1_epu.g decomped_epu.g
     NOEXEPREFIX NOEXESUFFIX
     NUM_MPI_PROCS ${NPROCS}
    TEST_4 EXEC epu ARGS -auto decomped_epu.g
       DIRECTORY ../../../../applications/epu
       NOEXEPREFIX NOEXESUFFIX
       NUM_MPI_PROCS 1
    TEST_5 EXEC exodiff ARGS -pedantic grouped1_epu.g decomped_epu.g
       DIRECTORY ../../../../applications/exodiff
       NOEXEPREFIX NOEXESUFFIX
       NUM_MPI_PROCS 1
    COMM mpi serial
    XHOSTTYPE Windows
    FINAL_PASS_REGULAR_EXPRESSION
  )
endif()

if (${CMAKE_PROJECT_NAME}_ENABLE_SEACASConjoin)
  # Use io_shell to generate several files with each timestep in a separate file
  # Then join those separate files into a single file with each in a separate changeset
  # Then use conjoin to "squash" the changesets into a single "normal" file
  # Compare this file with the same file generated without using changesets...
  TRIBITS_ADD_ADVANCED_TEST(
    io_shell_cs_time_conjoin
    TEST_0 NOEXEPREFIX NOEXESUFFIX EXEC io_shell ARGS ${SPLIT_ARG} ${IOSHELL_ARG} csplits.g
    TEST_1 NOEXEPREFIX NOEXESUFFIX EXEC io_shell ARGS csplits.g_1 csplits.g_2 csplits.g_3 csplits.g_4  changesets.g
    TEST_2 EXEC conjoin  ARGS --output conjoined.g --element_status_variable=NONE --nodal_status_variable=NONE changesets.g 
       DIRECTORY ../../../../applications/conjoin
       NOEXEPREFIX NOEXESUFFIX
       NUM_MPI_PROCS 1
    TEST_3 NOEXEPREFIX NOEXESUFFIX EXEC io_shell ARGS ${IOSHELL_ARG} generated.g
    TEST_4 EXEC exodiff ARGS -pedantic conjoined.g generated.g
       DIRECTORY ../../../../applications/exodiff
       NOEXEPREFIX NOEXESUFFIX
       NUM_MPI_PROCS 1
    COMM serial
    FINAL_PASS_REGULAR_EXPRESSION
  )

  # Use io_shell to generate multiple files with different geometry, but similar variable names
  # Then join those separate files into a single file with each in a separate changeset
  # Then use conjoin to "squash" the changesets into a single "normal" file
  # Then use conjoin to "squash" the individual files into a single "normal" file
  # Compare the two conjoin outputs...
  SET(GENARG tdelta:0.1+variables:global,1,nodal,2,element,3+bbox:0,0,0,1,1,1)
  TRIBITS_ADD_ADVANCED_TEST(
    io_shell_cs_geometry_conjoin
    TEST_0 NOEXEPREFIX NOEXESUFFIX EXEC io_shell ARGS --in_type generated 1x1x1+times:2+tinit:0.0+${GENARG} single.g
    TEST_1 NOEXEPREFIX NOEXESUFFIX EXEC io_shell ARGS --in_type generated 2x2x2+times:2+tinit:0.3+${GENARG} double.g
    TEST_2 NOEXEPREFIX NOEXESUFFIX EXEC io_shell ARGS --in_type generated 3x3x3+times:2+tinit:0.5+${GENARG} triple.g
    TEST_3 NOEXEPREFIX NOEXESUFFIX EXEC io_shell ARGS --in_type generated 4x4x4+times:2+tinit:0.7+${GENARG} quad.g
    TEST_4 NOEXEPREFIX NOEXESUFFIX EXEC io_shell ARGS single.g double.g triple.g quad.g  geometry.g
    TEST_5 EXEC conjoin  ARGS --output cs_conjoined.g geometry.g 
       DIRECTORY ../../../../applications/conjoin
       NOEXEPREFIX NOEXESUFFIX
       NUM_MPI_PROCS 1
    TEST_6 EXEC conjoin  ARGS --output raw_conjoined.g single.g double.g triple.g quad.g
       DIRECTORY ../../../../applications/conjoin
       NOEXEPREFIX NOEXESUFFIX
       NUM_MPI_PROCS 1
    TEST_7 EXEC exodiff ARGS -pedantic cs_conjoined.g raw_conjoined.g
       DIRECTORY ../../../../applications/exodiff
       NOEXEPREFIX NOEXESUFFIX
       NUM_MPI_PROCS 1
    COMM serial
    FINAL_PASS_REGULAR_EXPRESSION
  )
endif()
endif()

if (TPL_ENABLE_MPI)
  IF (TPL_Netcdf_PARALLEL)
    TRIBITS_ADD_ADVANCED_TEST(exodus_fpp_serialize
       TEST_0 EXEC io_shell ARGS ${DECOMP_ARG} ${SERIALIZE_ARG} ${CMAKE_CURRENT_SOURCE_DIR}/test/8-block.g 8-block32-ser.g
          NOEXEPREFIX NOEXESUFFIX
          NUM_MPI_PROCS ${NPROCS}
       TEST_1 EXEC io_shell ARGS ${JOIN_ARG} ${SERIALIZE_ARG} 8-block32-ser.g 8-block-32-serj.g
          NOEXEPREFIX NOEXESUFFIX
          NUM_MPI_PROCS ${NPROCS}
       TEST_2 EXEC exodiff ARGS -map -stat -pedantic ${CMAKE_CURRENT_SOURCE_DIR}/test/8-block.g 8-block-32-serj.g
          DIRECTORY ../../../../applications/exodiff
          NOEXEPREFIX NOEXESUFFIX
          NUM_MPI_PROCS 1
    COMM mpi
    XHOSTTYPE Windows
    )
  endif()

  TRIBITS_ADD_ADVANCED_TEST(create_path_fpp
     TEST_0 CMND rm ARGS -rf create_path_test_directory
     TEST_1 EXEC io_shell ARGS --in_type generated 100x100x100 create_path_test_directory/1/2/3/4/5/tmp.g
       NOEXEPREFIX NOEXESUFFIX
       NUM_MPI_PROCS ${NPROCS}
     TEST_2 CMND ls ARGS -1 create_path_test_directory/1/2/3/4/5/
     )

  TRIBITS_ADD_ADVANCED_TEST(exodus32_to_exodus64
     TEST_0 EXEC io_shell ARGS -64 ${DECOMP_ARG} ${JOIN_ARG} ${CMAKE_CURRENT_SOURCE_DIR}/test/8-block.g 8-block64.g
       NOEXEPREFIX NOEXESUFFIX
       NUM_MPI_PROCS ${NPROCS}
     TEST_1 EXEC exodiff ARGS -pedantic ${CMAKE_CURRENT_SOURCE_DIR}/test/8-block.g 8-block64.g
       DIRECTORY ../../../../applications/exodiff
       NOEXEPREFIX NOEXESUFFIX
       NUM_MPI_PROCS 1

    COMM mpi serial
    )

  TRIBITS_ADD_ADVANCED_TEST(exodus32_to_exodus32_pnetcdf
     TEST_0 EXEC io_shell ARGS ${DECOMP_ARG} ${PJOIN_ARG} ${CMAKE_CURRENT_SOURCE_DIR}/test/8-block.g 8-block64p.g
       NOEXEPREFIX NOEXESUFFIX
       NUM_MPI_PROCS ${NPROCS}
     TEST_1 EXEC exodiff ARGS -pedantic ${CMAKE_CURRENT_SOURCE_DIR}/test/8-block.g 8-block64p.g
       DIRECTORY ../../../../applications/exodiff
       NOEXEPREFIX NOEXESUFFIX
       NUM_MPI_PROCS 1
    COMM mpi serial
    )
ENDIF()

IF (SEACASIoss_ENABLE_THREADSAFE)
  TRIBITS_ADD_EXECUTABLE(
    io_shell_ts
    NOEXEPREFIX
    NOEXESUFFIX
    SOURCES io_shell_ts.C shell_interface.C
    INSTALLABLE
    )

  if (TPL_ENABLE_MPI)
     SET(IOSHELL_ARG --compose --in_type generated 10x10x10+shell:xXyYzZ+sideset:xXyY+times:2+variables:element,2,nodal,3,sideset,4)
  else()
     SET(IOSHELL_ARG --in_type generated 10x10x10+shell:xXyYzZ+sideset:xXyY+times:2+variables:element,2,nodal,3,sideset,4)
  endif()
  TRIBITS_ADD_ADVANCED_TEST(
    io_shell_ts
    TEST_0 NOEXEPREFIX NOEXESUFFIX EXEC io_shell_ts ARGS ${IOSHELL_ARG} gen-shell-ts.g
    TEST_1 NOEXEPREFIX NOEXESUFFIX EXEC io_shell    ARGS ${IOSHELL_ARG} gen-shell.g
    TEST_2 EXEC exodiff ARGS -pedantic gen-shell-ts.g gen-shell.g
       DIRECTORY ../../../../applications/exodiff
       NOEXEPREFIX NOEXESUFFIX
       NUM_MPI_PROCS 1
    COMM mpi serial
    FINAL_PASS_REGULAR_EXPRESSION
  )

  if (TPL_Netcdf_Enables_Netcdf4)
  SET(IOSHELL_ARG --split_times 1 --in_type generated 10x10x10+shell:xXyYzZ+times:4+variables:element,2,nodal,3)
  TRIBITS_ADD_ADVANCED_TEST(
    io_shell_ts_group_ungroup
    TEST_0 NOEXEPREFIX NOEXESUFFIX EXEC io_shell    ARGS ${IOSHELL_ARG} splits_ts.g
    TEST_1 NOEXEPREFIX NOEXESUFFIX EXEC io_shell_ts ARGS splits_ts.g_1 splits_ts.g_2 splits_ts.g_3 splits_ts.g_4  grouped_ts.g

=== PKGBUILD ===
# Maintainer: Rafał Brzegowy <rafal.brzegowy@yahoo.com>

_realname=seacas
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=2025.02.27
_releases=${pkgver//./-}
pkgrel=1
pkgdesc="The Sandia Engineering Analysis Code Access System (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://gsjaardema.github.io/seacas/"
msys2_repository_url="https://github.com/gsjaardema/seacas"
license=('spdx:BSD-3-Clause')
conflicts=("${MINGW_PACKAGE_PREFIX}-libexodus")
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-fmt"
         "${MINGW_PACKAGE_PREFIX}-hdf5"
         "${MINGW_PACKAGE_PREFIX}-libwinpthread-git"
         "${MINGW_PACKAGE_PREFIX}-metis"
         "${MINGW_PACKAGE_PREFIX}-matio"
         "${MINGW_PACKAGE_PREFIX}-netcdf")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-python")
source=("https://github.com/gsjaardema/seacas/archive/v${_releases}/${_realname}-${pkgver}.tar.gz"
        "0001-cmake-add-libs.patch"
        "0002-cmake-findHDF5.patch")
sha256sums=('3906FEDF17E0A5F1C6F941CB94B56134F41ABE4DA89F4EC25766FC33B327F521'
            'a3561756bfdeb942fc62add0aefa542b0e689b76a7f0d2d357e299465ee344d2'
            '09c4406d57c5ca18b0d2f16161dd6f5e2c5d56f0f73e83bd77272d876569d5cc')
noextract=(${_realname}-${pkgver}.tar.gz)

prepare() {
  plain "Extract ${_realname}-${pkgver}.tar.gz..."
  tar -xzf ${_realname}-${pkgver}.tar.gz || true

  cd "${srcdir}/${_realname}-${_releases}"
  patch -p1 -i "${srcdir}/0001-cmake-add-libs.patch"
  patch -p1 -i "${srcdir}/0002-cmake-findHDF5.patch"
}

build() {
  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  #Static Build
  mkdir -p "${_realname}-${_releases}/build-${MSYSTEM}-static" && cd "${_realname}-${_releases}/build-${MSYSTEM}-static"

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    INSTALL_PATH=${MINGW_PREFIX} \
    THREADSAFE=ON \
    ../cmake-config \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
      ${extra_config[@]} \
      -DCMAKE_C_COMPILER=${MINGW_PREFIX}/bin/${CC}.exe \
      -DCMAKE_CXX_COMPILER=${MINGW_PREFIX}/bin/${CXX}.exe \
      -DPython_EXECUTABLE=${MINGW_PREFIX}/bin/python.exe \
      -DSeacas_ENABLE_Fortran=OFF \
      -DTPL_ENABLE_X11=OFF \
      -DSeacas_ENABLE_TESTS=OFF \
      -DBUILD_SHARED_LIBS=OFF

  ${MINGW_PREFIX}/bin/cmake --build .

  #Shared Build
  mkdir -p "../build-${MSYSTEM}-shared" && cd "../build-${MSYSTEM}-shared"

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    INSTALL_PATH=${MINGW_PREFIX} \
    THREADSAFE=ON \
    ../cmake-config \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
      ${extra_config[@]} \
      -DCMAKE_C_COMPILER=${MINGW_PREFIX}/bin/${CC}.exe \
      -DCMAKE_CXX_COMPILER=${MINGW_PREFIX}/bin/${CXX}.exe \
      -DPython_EXECUTABLE=${MINGW_PREFIX}/bin/python.exe \
      -DSeacas_ENABLE_Fortran=OFF \
      -DTPL_ENABLE_X11=OFF \
      -DSeacas_ENABLE_TESTS=OFF \
      -DBUILD_SHARED_LIBS=ON

  ${MINGW_PREFIX}/bin/cmake --build .
}

package() {
  #Static Install
  cd "${srcdir}/${_realname}-${_releases}/build-${MSYSTEM}-static"
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install .

  #Shared Install
  cd "${srcdir}/${_realname}-${_releases}/build-${MSYSTEM}-shared"
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install .

  install -Dm644 "${srcdir}"/${_realname}-${_releases}/LICENSE \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE

  local PREFIX_WIN=$(cygpath -wm ${MINGW_PREFIX})
  for _f in $(find "${pkgdir}"${MINGW_PREFIX}/lib -type f -name '*.cmake'); do
    sed -e "s|${PREFIX_WIN}|\$\{CMAKE_CURRENT_LIST_DIR\}/../../..|g" -i ${_f}
    sed -e "s|${MINGW_PREFIX}|\$\{CMAKE_CURRENT_LIST_DIR\}/../../..|g" -i ${_f}
  done
}

=== debian/control ===
Source: seacas
Priority: optional
Maintainer: Nico Schlömer <nico.schloemer@gmail.com>
Build-Depends: debhelper (>= 9),
  cmake (>= 2.8.12),
  gfortran,
  libhdf5-dev,
  libmatio-dev,
  libmetis-dev,
  libnetcdf-dev,
  libparmetis-dev,
  libz-dev
Standards-Version: 3.9.6
Section: libs
Homepage: https://github.com/gdsjaar/seacas

Package: libseacas-dev
Section: libdevel
Architecture: any
Depends: libseacas0 (= ${binary:Version}), ${misc:Depends}
Description: processing tools and applications for finite element analysis
 The Sandia Engineering Analysis Code Access System (SEACAS) is a suite of
 preprocessing, postprocessing, translation, and utility applications
 supporting finite element analysis software using the ExodusII database file
 format.
 .
 This package contains development headers.

Package: libseacas0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: processing tools and applications for finite element analysis
 The Sandia Engineering Analysis Code Access System (SEACAS) is a suite of
 preprocessing, postprocessing, translation, and utility applications
 supporting finite element analysis software using the ExodusII database file
 format.
 .
 This package contains the libraries.

Package: seacas-bin
Section: libs
Architecture: any
Depends: libseacas0, ${misc:Depends}
Description: processing tools and applications for finite element analysis
 The Sandia Engineering Analysis Code Access System (SEACAS) is a suite of
 preprocessing, postprocessing, translation, and utility applications
 supporting finite element analysis software using the ExodusII database file
 format.
 .
 This package contains executables.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=cmake --parallel

# TODO turn on tests as soon when <https://github.com/gdsjaar/seacas/issues/7>
# is resolved.
override_dh_auto_configure:
	dh_auto_configure -- \
  -DBUILD_SHARED_LIBS:BOOL=ON \
  -DCMAKE_SKIP_INSTALL_RPATH:BOOL=ON \
  -DHDF5_ROOT:PATH=/usr/ \
  -DSeacas_ENABLE_ALL_PACKAGES:BOOL=ON \
  -DSeacas_ENABLE_TESTS:BOOL=OFF \
  -DTPL_ENABLE_CGNS:BOOL=OFF \
  -DTPL_ENABLE_Matio:BOOL=ON \
  -DTPL_ENABLE_METIS:BOOL=ON \
  -DTPL_ENABLE_ParMETIS:BOOL=ON \
  -DTPL_ENABLE_Netcdf:BOOL=ON \
  -DTPL_ENABLE_MPI:BOOL=OFF \
  -DTPL_ENABLE_Pamgen:BOOL=OFF \
  -DTPL_ENABLE_X11:BOOL=OFF \
  -DTPL_ENABLE_Zlib:BOOL=ON
